diff --git a/lib/librte_ether/rte_ethdev.h b/lib/librte_ether/rte_ethdev.h
index 544afe0..b2ff337 100644
--- a/lib/librte_ether/rte_ethdev.h
+++ b/lib/librte_ether/rte_ethdev.h
@@ -244,7 +244,7 @@ struct rte_eth_link {
 	uint16_t link_speed;      /**< ETH_LINK_SPEED_[10, 100, 1000, 10000] */
 	uint16_t link_duplex;     /**< ETH_LINK_[HALF_DUPLEX, FULL_DUPLEX] */
 	uint8_t  link_status : 1; /**< 1 -> link up, 0 -> link down */
-}__attribute__((aligned(8)));     /**< aligned for atomic64 read/write */
+} __attribute__((aligned(8)));     /**< aligned for atomic64 read/write */
 
 #define ETH_LINK_SPEED_AUTONEG  0       /**< Auto-negotiate link speed. */
 #define ETH_LINK_SPEED_10       10      /**< 10 megabits/second. */
@@ -746,7 +746,7 @@ enum rte_l4type {
  */
 enum rte_iptype {
 	RTE_FDIR_IPTYPE_IPV4 = 0,     /**< IPv4. */
-	RTE_FDIR_IPTYPE_IPV6 ,        /**< IPv6. */
+	RTE_FDIR_IPTYPE_IPV6,         /**< IPv6. */
 };
 
 /**
@@ -864,7 +864,7 @@ struct rte_eth_conf {
 	struct rte_eth_rxmode rxmode; /**< Port RX configuration. */
 	struct rte_eth_txmode txmode; /**< Port TX configuration. */
 	uint32_t lpbk_mode; /**< Loopback operation mode. By default the value
-			         is 0, meaning the loopback mode is disabled.
+				 is 0, meaning the loopback mode is disabled.
 				 Read the datasheet of given ethernet controller
 				 for details. The possible values of this field
 				 are defined in implementation of each driver. */
@@ -1454,15 +1454,15 @@ struct eth_dev_ops {
 	/**< Set eeprom */
   /* bypass control */
 #ifdef RTE_NIC_BYPASS
-  bypass_init_t bypass_init;
-  bypass_state_set_t bypass_state_set;
-  bypass_state_show_t bypass_state_show;
-  bypass_event_set_t bypass_event_set;
-  bypass_event_show_t bypass_event_show;
-  bypass_wd_timeout_set_t bypass_wd_timeout_set;
-  bypass_wd_timeout_show_t bypass_wd_timeout_show;
-  bypass_ver_show_t bypass_ver_show;
-  bypass_wd_reset_t bypass_wd_reset;
+	bypass_init_t bypass_init;
+	bypass_state_set_t bypass_state_set;
+	bypass_state_show_t bypass_state_show;
+	bypass_event_set_t bypass_event_set;
+	bypass_event_show_t bypass_event_show;
+	bypass_wd_timeout_set_t bypass_wd_timeout_set;
+	bypass_wd_timeout_show_t bypass_wd_timeout_show;
+	bypass_ver_show_t bypass_ver_show;
+	bypass_wd_reset_t bypass_wd_reset;
 #endif
 
 	/** Configure RSS hash protocols. */
@@ -1628,10 +1628,10 @@ struct rte_eth_dev_data {
 	/**< Common rx buffer size handled by all queues */
 
 	uint64_t rx_mbuf_alloc_failed; /**< RX ring mbuf allocation failures. */
-	struct ether_addr* mac_addrs;/**< Device Ethernet Link address. */
+	struct ether_addr *mac_addrs; /**< Device Ethernet Link address. */
 	uint64_t mac_pool_sel[ETH_NUM_RECEIVE_MAC_ADDR];
 	/** bitmap array of associating Ethernet MAC addresses to pools */
-	struct ether_addr* hash_mac_addrs;
+	struct ether_addr *hash_mac_addrs;
 	/** Device Ethernet MAC addresses of hash filtering. */
 	uint8_t port_id;           /**< Device [external] port identifier. */
 	uint8_t promiscuous   : 1, /**< RX promiscuous mode ON(1) / OFF(0). */
@@ -2342,7 +2342,7 @@ extern int rte_eth_dev_set_mtu(uint8_t port_id, uint16_t mtu);
  *   - (-ENOSYS) if VLAN filtering on *port_id* disabled.
  *   - (-EINVAL) if *vlan_id* > 4095.
  */
-extern int rte_eth_dev_vlan_filter(uint8_t port_id, uint16_t vlan_id , int on);
+extern int rte_eth_dev_vlan_filter(uint8_t port_id, uint16_t vlan_id, int on);
 
 /**
  * Enable/Disable hardware VLAN Strip by a rx queue of an Ethernet device.
@@ -2563,10 +2563,10 @@ extern uint32_t rte_eth_rx_queue_count(uint8_t port_id, uint16_t queue_id);
 static inline uint32_t
 rte_eth_rx_queue_count(uint8_t port_id, uint16_t queue_id)
 {
-        struct rte_eth_dev *dev;
+	struct rte_eth_dev *dev;
 
-        dev = &rte_eth_devices[port_id];
-        return (*dev->dev_ops->rx_queue_count)(dev, queue_id);
+	dev = &rte_eth_devices[port_id];
+	return (*dev->dev_ops->rx_queue_count)(dev, queue_id);
 }
 #endif
 
@@ -2595,8 +2595,8 @@ rte_eth_rx_descriptor_done(uint8_t port_id, uint16_t queue_id, uint16_t offset)
 	struct rte_eth_dev *dev;
 
 	dev = &rte_eth_devices[port_id];
-	return (*dev->dev_ops->rx_descriptor_done)( \
-		dev->data->rx_queues[queue_id], offset);
+	return (*dev->dev_ops->rx_descriptor_done)
+		(dev->data->rx_queues[queue_id], offset);
 }
 #endif
 
@@ -2911,8 +2911,8 @@ enum rte_eth_event_type {
 	RTE_ETH_EVENT_MAX       /**< max value of this enum */
 };
 
-typedef void (*rte_eth_dev_cb_fn)(uint8_t port_id, \
-		enum rte_eth_event_type event, void *cb_arg);
+typedef void (*rte_eth_dev_cb_fn)(uint8_t port_id,
+				  enum rte_eth_event_type event, void *cb_arg);
 /**< user application callback to be registered for interrupts */
 
 
@@ -3246,8 +3246,8 @@ int rte_eth_dev_rss_reta_query(uint8_t port,
   *  - (-ENODEV) if *port_id* invalid.
  *   - (-EINVAL) if bad parameter.
  */
-int rte_eth_dev_uc_hash_table_set(uint8_t port,struct ether_addr *addr,
-					uint8_t on);
+int rte_eth_dev_uc_hash_table_set(uint8_t port, struct ether_addr *addr,
+				  uint8_t on);
 
  /**
  * Updates all unicast hash bitmaps for receiving packet with any Unicast
@@ -3266,7 +3266,7 @@ int rte_eth_dev_uc_hash_table_set(uint8_t port,struct ether_addr *addr,
   *  - (-ENODEV) if *port_id* invalid.
  *   - (-EINVAL) if bad parameter.
  */
-int rte_eth_dev_uc_all_hash_table_set(uint8_t port,uint8_t on);
+int rte_eth_dev_uc_all_hash_table_set(uint8_t port, uint8_t on);
 
  /**
  * Set RX L2 Filtering mode of a VF of an Ethernet device.
@@ -3310,7 +3310,7 @@ int rte_eth_dev_set_vf_rxmode(uint8_t port, uint16_t vf, uint16_t rx_mode,
 *   - (-EINVAL) if bad parameter.
 */
 int
-rte_eth_dev_set_vf_tx(uint8_t port,uint16_t vf, uint8_t on);
+rte_eth_dev_set_vf_tx(uint8_t port, uint16_t vf, uint8_t on);
 
 /**
 * Enable or disable a VF traffic receive of an Ethernet device.
@@ -3329,7 +3329,7 @@ rte_eth_dev_set_vf_tx(uint8_t port,uint16_t vf, uint8_t on);
 *   - (-EINVAL) if bad parameter.
 */
 int
-rte_eth_dev_set_vf_rx(uint8_t port,uint16_t vf, uint8_t on);
+rte_eth_dev_set_vf_rx(uint8_t port, uint16_t vf, uint8_t on);
 
 /**
 * Enable/Disable hardware VF VLAN filtering by an Ethernet device of